﻿<%@ Import Namespace="System"%>
<%@ Import Namespace="System.Configuration"%>
<%@ Import Namespace="System.Data.SqlClient" %> 
<%@ Import Namespace="System.Data" %>

<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>

<% 
    int page = 0;
    int total = 0;
    int limit = 3;//Records per page
    int adjacents = 1;
    int start = 0;
    int prev = 0;
    int next = 0;
    int lastpage = 0;
    int lpm1 = 0;
    int counter = 0;
    string connection_string = "Data Source=DESKTOP-O4U8KQF;Initial Catalog=asp_pagination;Integrated Security=True";

    SqlConnection con = new SqlConnection(connection_string);
    con.Open();

    using (SqlCommand command = new SqlCommand(
    "GetUsersCount_SP", con))
    {
        command.CommandType = CommandType.StoredProcedure;
        object count = command.ExecuteScalar();
        total = int.Parse(count.ToString());
    }

    if (!string.IsNullOrEmpty(Request.QueryString["page"]))
    {
        page = Convert.ToInt32(Request.QueryString["page"]);
    }

    if (page == 0) page = 1;
    prev = page - 1;
    next = page + 1;
    //Recheck next line of code if you are getting correct number of pages from it.
    //I checked it with above 5000 rows, it was working fine for me.
    lastpage = Convert.ToInt32(Math.Round(Convert.ToDecimal(total / limit)));
    lpm1 = lastpage - 1;


    DataTable dt = new DataTable();
    using (SqlCommand command = new SqlCommand(
    "GetUsers_SP", con))
    {
        command.CommandType = CommandType.StoredProcedure;
        command.Parameters.Add("@PageNo", SqlDbType.Int).Value = page;
        command.Parameters.Add("@PageSize", SqlDbType.Int).Value = limit;

        SqlDataAdapter adapter = new SqlDataAdapter(command);
        adapter.Fill(dt);
    }
    con.Close();

    foreach (DataRow row in dt.Rows)
    {
        string ID = row["ID"].ToString();
        string Name = row["Name"].ToString();
        string Country = row["Country"].ToString();


        string addRow = string.Format("<tr><td>{0}</td><td>{1}</td><td>{2}</td></tr>", ID, Name, Country);

        Records.Text += addRow; //Show the data
    }

    string pagination = "";
    if (lastpage > 1)
    {
        pagination += "<ul class='pagination'>";
        //previous button
        if (page > 1)
            pagination = pagination + "<li class='page-item'><a class='page-link' href='Default.aspx?page=" + prev + "'>←</a></li>";
        else
            pagination += "<li class='page-item disabled'><a class='page-link'>←</a></li>";

        //pages 
        if (lastpage < 7 + (adjacents * 2)) //not enough pages to bother breaking it up
        {
            for (counter = 1; counter <= lastpage; counter++)
            {
                if (counter == page)
                    pagination += "<li class='page-item disabled'><a class='page-link'>" + counter + "</a></li>";
                else
                    pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=" + counter + "'>" + counter + "</a></li>";
            }
        }
        else if (lastpage > 5 + (adjacents * 2))  //enough pages to hide some
        {
            //close to beginning; only hide later pages
            if (page < 1 + (adjacents * 2))
            {
                for (counter = 1; counter < 4 + (adjacents * 2); counter++)
                {
                    if (counter == page)
                        pagination += "<li class='page-item active'><a class='page-link'>" + counter + "</a></li>";
                    else
                        pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=" + counter + "'>" + counter + "</a></li>";
                }
                pagination += "<li class='page-item disabled'><a class='page-link'>...</a></li>";
                pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=" + lpm1 + "'>" + lpm1 + "</a></li>";
                pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=" + lastpage + "'>" + lastpage + "</a></li>";
            }
            //in middle; hide some front and some back
            else if (lastpage - (adjacents * 2) > page && page > (adjacents * 2))
            {
                pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=1'>1</a></li>";
                pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=2'>2</a></li>";
                pagination += "<li class='page-item disabled'><a class='page-link'>...</a></li>";
                for (counter = page - adjacents; counter <= page + adjacents; counter++)
                {
                    if (counter == page)
                        pagination += "<li class='page-item disabled'><a class='page-link'>" + counter + "</a></li>";
                    else
                        pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=" + counter + "'>" + counter + "</a></li>";
                }
                pagination += "<li class='page-item disabled'><a class='page-link'>...</a></li>";
                pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=" + lpm1 + "'>" + lpm1 + "</a></li>";
                pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=" + lastpage + "'>" + lastpage + "</a></li>";
            }
            //close to end; only hide early pages
            else
            {
                pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=1'>1</a></li>";
                pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=2'>2</a></li>";
                pagination += "<li class='page-item disabled'><a class='page-link'>...</a></li>";
                for (counter = lastpage - (2 + (adjacents * 2)); counter <= lastpage; counter++)
                {
                    if (counter == page)
                        pagination += "<li class='page-item active'><a class='page-link'>" + counter + "</a></li>";
                    else
                        pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=" + counter + "'>" + counter + "</a></li>";
                }
            }
        }
        //next button
        if (page < counter - 1)
            pagination += "<li class='page-item'><a class='page-link' href='Default.aspx?page=" + next + "'>→</a></li>";
        else
            pagination += "<li class='page-item'><a class='page-link'>→</a></li>";
        pagination += "</ul>";
    }

    Pagination.Text = pagination;//Show the data


%>
<!DOCTYPE html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-alpha.6/css/bootstrap.min.css" integrity="sha384-rwoIResjU2yc3z8GV/NPeZWAv56rSmLldC3R/AZzGRnGxQQKnKkoFVhFQhNUwEyJ" crossorigin="anonymous">
  </head>
  <body>
      <table>
          <asp:Label ID="Records" Text="" runat="server"></asp:Label>
      </table>
      
      <asp:Label ID="Pagination" Text="" runat="server"></asp:Label>

    <!-- jQuery first, then Tether, then Bootstrap JS. -->
    <script src="https://code.jquery.com/jquery-3.1.1.slim.min.js" integrity="sha384-A7FZj7v+d/sdmMqp/nOQwliLvUsJfDHW+k9Omg/a/EheAdgtzNs3hpfag6Ed950n" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/tether/1.4.0/js/tether.min.js" integrity="sha384-DztdAPBWPRXSA/3eYEEUWrWCy7G5KFbe8fFjk5JAIxUYHKkDx6Qin1DkWx51bBrb" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-alpha.6/js/bootstrap.min.js" integrity="sha384-vBWWzlZJ8ea9aCX4pEW3rVHjgjt7zpkNpZk+02D9phzyeVkE+jo0ieGizqPLForn" crossorigin="anonymous"></script>
  </body>
</html>
